#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# coding: utf-8

"""
    KFServing

    Python SDK for KFServing  # noqa: E501

    The version of the OpenAPI document: v0.1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from kserve.configuration import Configuration


class V1alpha2EndpointSpec(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'explainer': 'V1alpha2ExplainerSpec',
        'predictor': 'V1alpha2PredictorSpec',
        'transformer': 'V1alpha2TransformerSpec'
    }

    attribute_map = {
        'explainer': 'explainer',
        'predictor': 'predictor',
        'transformer': 'transformer'
    }

    def __init__(self, explainer=None, predictor=None, transformer=None, local_vars_configuration=None):  # noqa: E501
        """V1alpha2EndpointSpec - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._explainer = None
        self._predictor = None
        self._transformer = None
        self.discriminator = None

        if explainer is not None:
            self.explainer = explainer
        self.predictor = predictor
        if transformer is not None:
            self.transformer = transformer

    @property
    def explainer(self):
        """Gets the explainer of this V1alpha2EndpointSpec.  # noqa: E501


        :return: The explainer of this V1alpha2EndpointSpec.  # noqa: E501
        :rtype: V1alpha2ExplainerSpec
        """
        return self._explainer

    @explainer.setter
    def explainer(self, explainer):
        """Sets the explainer of this V1alpha2EndpointSpec.


        :param explainer: The explainer of this V1alpha2EndpointSpec.  # noqa: E501
        :type: V1alpha2ExplainerSpec
        """

        self._explainer = explainer

    @property
    def predictor(self):
        """Gets the predictor of this V1alpha2EndpointSpec.  # noqa: E501


        :return: The predictor of this V1alpha2EndpointSpec.  # noqa: E501
        :rtype: V1alpha2PredictorSpec
        """
        return self._predictor

    @predictor.setter
    def predictor(self, predictor):
        """Sets the predictor of this V1alpha2EndpointSpec.


        :param predictor: The predictor of this V1alpha2EndpointSpec.  # noqa: E501
        :type: V1alpha2PredictorSpec
        """
        if self.local_vars_configuration.client_side_validation and predictor is None:  # noqa: E501
            raise ValueError("Invalid value for `predictor`, must not be `None`")  # noqa: E501

        self._predictor = predictor

    @property
    def transformer(self):
        """Gets the transformer of this V1alpha2EndpointSpec.  # noqa: E501


        :return: The transformer of this V1alpha2EndpointSpec.  # noqa: E501
        :rtype: V1alpha2TransformerSpec
        """
        return self._transformer

    @transformer.setter
    def transformer(self, transformer):
        """Sets the transformer of this V1alpha2EndpointSpec.


        :param transformer: The transformer of this V1alpha2EndpointSpec.  # noqa: E501
        :type: V1alpha2TransformerSpec
        """

        self._transformer = transformer

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, V1alpha2EndpointSpec):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, V1alpha2EndpointSpec):
            return True

        return self.to_dict() != other.to_dict()
